#!/usr/bin/env bash

# This script is called by p1.test.user.bash
# It runs as atlascdr on the test host.

cd `dirname $0`
SOURCE_DIR=`pwd`/..
REMOTE_DIR="/eos/atlas/atlastier0/daq/test/CastorScript.tests"

echo "Cleaning remote EOS test area: $REMOTE_DIR"
KEYTAB_FILE="/daq_area/castor/`hostname`/atlascdr/atlascdr.keytab"
kinit -kt $KEYTAB_FILE atlascdr
for i in $(seq 0 9); do
	echo "Removing: dummy$i.data"
	xrd eosatlas rm /eos/atlas/atlastier0/daq/test/CastorScript.tests/dummy$i.data &> /dev/null
done

TMP_DIR=/tmp/atlascdr
echo "Cleaning tmp directory: $TMP_DIR"
rm -rf $TMP_DIR
mkdir -p $TMP_DIR/logs

echo "Creating dummy data files"
for i in `seq 0 9`; do
	dd if=/dev/zero of=$TMP_DIR/dummy$i.data bs=1k count=1
done

echo "Starting CastorScript"
source $SOURCE_DIR/script_setup.sh
python -u $SOURCE_DIR/Script/CastorScript.py $SOURCE_DIR/Test/test_config.cfg &


echo "Watching files to transfer"
while ls -l $TMP_DIR/dummy* ; do
	sleep 1
	echo
	date
done

echo "Stopping CastorScript"
~flegoff/castor_tools/signal-script.sh 12

echo "Cleaning remote files"
for i in $(seq 0 9); do
	echo "Removing: /eos/atlas/atlastier0/daq/test/CastorScript.tests/dummy$i.data"
	xrd eosatlas rm /eos/atlas/atlastier0/daq/test/CastorScript.tests/dummy$i.data
done

echo "Check logs at: $TMP_DIR/logs"
echo "Don't forget to: rm -rf $TMP_DIR"
