
from subprocess import Popen, PIPE
import time

#For timing timeouts
class Timer():
    def __init__(self, seconds):
        self.startTime = time.time()
        self.endTime = self.startTime + seconds
        self.timedout = False
    
    def timesUp(self):
        if (self.endTime < time.time()): 
            self.timedout = True
            return True
        else: 
            return False

    def timesNotUp(self):
        return not self.timesUp()

#For checking a dir
class DirectoryChecker():
    def __init__(self, dirPath):
        self.dirPath = dirPath
        self.lsOutput = None
        self.wasEmpty = None
        self.timerUtil = None

    def waitForAnyFile(self, seconds):
        timeToTimeout = seconds
        self.timerUtil = Timer(timeToTimeout)
        while self.checkIfEmpty() and self.timerUtil.timesNotUp():
            pass

    def waitForEmptyDir(self, seconds):
        timeToTimeout = seconds
        self.timerUtil = Timer(timeToTimeout)
        while self.checkIfNotEmpty() and self.timerUtil.timesNotUp():
            pass

    def checkIfEmpty(self):
        if len(self.getLsOutput()) > 1:
            self.wasEmpty = False
            return False
        else:
            self.wasEmpty = True
            return True

    def checkIfNotEmpty(self):
        return not self.checkIfEmpty()

    def checkIfContains(self, substring):
        if self.getLsOutput().find(substring) > -1:
            return True
        else: 
            return False
        
    def getLsOutput(self):
        self.lsOutput = str(Popen(["ls", self.dirPath],bufsize=-1, stdout=PIPE).communicate()[0])
        return self.lsOutput

#Could be refactored
def findCastorScriptPids():
    # first find all running instances with this command
    # ps aux | grep CastorScript.py | grep -v grep | awk '{print $2}'

    # it get list of processes
    psCommand = Popen(["ps", "aux"], stdout=PIPE)
    
    # finds castorscript processes
    grepCommand = Popen(["grep", "CastorScript.py"], stdin=psCommand.stdout, stdout=PIPE)
    psCommand.stdout.close()
    
    # sorts grep out of the mix
    grepvCommand = Popen(["grep", "-v", "grep"], stdin=grepCommand.stdout, stdout=PIPE)
    grepCommand.stdout.close()

    # and finally gets the PIDs
    awkCommand =  Popen(["awk", "{print $2}"], stdin=grepvCommand.stdout, stdout=PIPE)
    grepvCommand.stdout.close()
    
    pids = str(awkCommand.communicate()[0]).splitlines()
    awkCommand.stdout.close()

    return pids