
"""
Helper module to test storage backends

"""


import sys
import logging
from optparse import OptionParser
import time


def copywrapper(module, srcfile, dstfile, stager, pool, logger):

    handle, _ = module.backgroundcopy(srcfile, dstfile, stager, pool, logger)

    state = None
    while state == None:
        state = module.copystate(handle)
        time.sleep(1)

    print module.copystdout(handle)


def execute(module):

    logger = logging.getLogger()
    logger.addHandler(logging.StreamHandler(sys.stdout))

    parser = OptionParser()
    parser.add_option("-c", "--command", dest="command",
                      help="command")
    parser.add_option("-t", "--target", dest="target",
                      help="remote target")
    parser.add_option("-s", "--stager", dest="stager",
                      help="stager name")
    parser.add_option("-p", "--pool", dest="pool",
                      help="pool name")
    parser.add_option("-o", "--opttarget", dest="opttarget",
                      help="optional target", default=None)

    (options, args) = parser.parse_args()

    stdopt = (options.target, options.stager, options.pool, logger)

    switch = {
        'sizechecksum':(module.sizechecksum, stdopt),
        'remove':(module.remove, stdopt),
        'mkdir':(module.mkdir, stdopt),
        'migrated':(module.migrated, stdopt),
        'backgroundcopy':(copywrapper, (module, options.target,
                                        options.opttarget, options.stager,
                                        options.pool, logger))
        }

    function, args = switch[options.command]

    print function(*args)
